IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc
    .686 ; for ml8
    .xmm

    l_htodw  PROTO :DWORD
    l_htodw2 PROTO :DWORD
    Axhex2dw_Unrolled PROTO:DWORD
    Axhex2dw_Unrolled_AMD PROTO:DWORD
    HexToBin PROTO :DWORD

    execute PROTO :DWORD,:DWORD,:DWORD,:DWORD

  ; 2 equates to control padding between algorithms

    ncnt equ <16>       ; padding count
    padd equ <db 0>     ; padding content

    .data
      align 16
      tablx dd 0,1,2,3,4,5,6,7,8,9
		dd 39 Dup(0)
            dd 0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pArr  :DWORD
    LOCAL aCnt  :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL tcnt  :DWORD
    LOCAL lpcn  :DWORD

    LOCAL acnt  :DWORD
    LOCAL lcnt  :DWORD
    LOCAL lcn2  :DWORD
    LOCAL jcn1  :DWORD
    LOCAL dcn1  :DWORD

    push ebx
    push esi
    push edi

    invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

    mov hMem, InputFile("hexnum.txt")               ; open source file
    mov flen, ecx

    invoke ltok,hMem,ADDR pArr                      ; tokenise it
    mov aCnt, eax

    print str$(aCnt)," = item count in file",13,10  ; display item count

    mov acnt, 0
    mov lcnt, 0
    mov lcn2, 0
    mov jcn1, 0
    mov dcn1, 0

  REPEAT 8

    print chr$(13,10,13,10)

    fn execute,ADDR l_htodw,pArr,aCnt,"Lingo 1"
    add lcnt, eax
  
    invoke SleepEx,500,0

    fn execute,ADDR l_htodw2,pArr,aCnt,"Lingo 2"
    add lcn2, eax

    invoke SleepEx,500,0

    fn execute,ADDR Axhex2dw_Unrolled,pArr,aCnt,"Alex Unrolled"
    add acnt, eax
    
    invoke SleepEx,500,0

    fn execute,ADDR Axhex2dw_Unrolled_AMD,pArr,aCnt,"Alex Unrolled (AMD)"
    add dcn1, eax

    invoke SleepEx,500,0

    ; this is a Jochen's version of hex2dw - which support more flexible strings and has SSE2 algo
    ; I comment it, because Hutch desire to see only integer versions in test.
    ;fn execute,ADDR HexToBin,pArr,aCnt,"JJ SSE2"
    ;add jcn1, eax

    invoke SleepEx,500,0

  ENDM

    shr lcnt, 3
    shr acnt, 3
    shr lcn2, 3
    shr jcn1, 3
    shr dcn1, 3

    print chr$(13,10,13,10)

    print str$(lcnt)," MS Lingo average",13,10
    print str$(lcn2)," MS Lingo2 average",13,10
    print str$(acnt)," MS Alex average",13,10
    print str$(dcn1)," MS Alex (AMD) average",13,10
    ; uncomment this while test Jochen's SSE2 flexible version
    ;print str$(jcn1)," MS JJ SSE2d average",13,10
    
    print " ",13,13,13,10
    print "Size of code:",13,10
    mov eax,offset l_htodw_endp-offset l_htodw
    print str$(eax),9," Lingo 1 proc",13,10
    mov eax,offset l_htodw2_endp-offset l_htodw2
    print str$(eax),9," Lingo 2 proc",13,10
    mov eax,offset Axhex2dw_Unrolled_endp-offset Axhex2dw_Unrolled
    print str$(eax),9," Alex proc",13,10
    mov eax,offset Axhex2dw_Unrolled_AMD_endp-offset Axhex2dw_Unrolled_AMD
    print str$(eax),9," Alex proc (AMD)",13,10
    ;mov eax,offset HexToBin_endp-offset HexToBin
    ;print str$(eax),9," Jochen proc (SSE2)",13,10

    print chr$(13,10,13,10)

    free hMem
    free pArr

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

execute proc pAlgo:DWORD,pArr:DWORD,aCnt:DWORD,pTxt:DWORD

    push ebx
    push esi
    push edi

    invoke GetTickCount                 ; start timing
    push eax

    mov ebx, 100                        ; outer loop count

  ; ====================================
  lbl0:
    xor esi, esi                        ; zero the inner loop counter ESI
    mov edi, pArr                       ; load the array address

  ; ------------------------------------
  @@:
    push [edi]                          ; push the string address
    call pAlgo                          ; call the algorithm address

    add edi, 4
    add esi, 1
    cmp esi, aCnt
    jl @B
  ; ------------------------------------

    sub ebx, 1
    test ebx, ebx
    jnz lbl0
  ; ====================================

    invoke GetTickCount                 ; end timing
    pop ecx
    sub eax, ecx
    push eax

    print str$(eax)," ms "
    print pTxt,13,10

    pop eax                             ; return the timing

    pop edi
    pop esi
    pop ebx

    ret

execute endp

; 

REPEAT ncnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
db 0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword

	mov		edx, [esp+4]
	mov		eax, 11011111Y 
	and      eax, [edx]
	mov		ecx, 11011111Y 
	jz			@f
	mov		eax, [tablx+eax*4-40h]
	and      ecx, [edx+1]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+2]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+3]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+4]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+5]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+6]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx, [edx+7]
	jz			@f
	shl	    eax, 4
	add		eax, [tablx+ecx*4-40h]
@@:
	ret		4
l_htodw  endp
l_htodw_endp:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

REPEAT ncnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled    endp
Axhex2dw_Unrolled_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

REPEAT ncnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
l_htodw2   proc lpString:dword
mov         edx, [esp+1*4]
push		ebx
mov         ebx, [edx]
xor           ecx, ecx 	
add          cl,    bl
je       		End1
mov         eax, [tabl8+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    bh
je       		End2
mov			edx, [edx+4]
add          eax, [tabl7+ecx*4-0C0h] 
xor           ecx, ecx 	
shr			ebx, 16
add          cl,    bl
je       		End3
add          eax, [tabl6+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    bh
je       		End4
add          eax, [tabl5+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    dl
je       		End5
add          eax, [tabl4+ecx*4-0C0h] 
xor			ecx, ecx 	
add          cl,    dh
je       	    End6
add          eax, [tabl3+ecx*4-0C0h] 
pop         ebx 
shr			edx, 16
xor           ecx, ecx 	
add          cl,    dl
je       	    End7
add          eax, [tabl2+ecx*4-0C0h] 
xor           ecx, ecx 	
add           cl,    dh
je       	     End8
add           eax, [tabl1+ecx*4-0C0h] 
ret			 4
align 16
End1:
pop			 ebx
ret		 	 4
align 16
End2:
shr			 eax, 28
pop			 ebx
ret 4
align 16
End3:
shr			 eax, 24
pop			 ebx
ret 4
align 16
End4:
shr			 eax, 20
pop			 ebx
ret 4
align 16
End5:
shr			 eax, 16
pop			 ebx
ret 4
align 16
End6:
shr			 eax, 12
pop			 ebx
ret 4
align 16
End7:
shr			 eax, 8
ret 4
align 16
End8:
shr			 eax, 4
ret 4
align 16
tabl1  dd   0,1,2,3,4,5,6,7,8,9
		  dd 	  7 Dup(0)
          dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
		  dd   26	Dup(0) 
		  dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
align 16
tabl2  dd   0,1*10h,2*10h,3*10h,4*10h,5*10h,6*10h,7*10h,8*10h,9*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
align 16
tabl3  dd   0,1*10h*10h,2*10h*10h,3*10h*10h,4*10h*10h,5*10h*10h,6*10h*10h,7*10h*10h,8*10h*10h,9*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
align 16
tabl4  dd   0,1*10h*10h*10h,2*10h*10h*10h,3*10h*10h*10h,4*10h*10h*10h,5*10h*10h*10h,6*10h*10h*10h,7*10h*10h*10h,8*10h*10h*10h,9*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
align 16
tabl5  dd   0,1*10h*10h*10h*10h,2*10h*10h*10h*10h,3*10h*10h*10h*10h,4*10h*10h*10h*10h,5*10h*10h*10h*10h,6*10h*10h*10h*10h,7*10h*10h*10h*10h,8*10h*10h*10h*10h,9*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
align 16
tabl6  dd   0,1*10h*10h*10h*10h*10h, 2*10h*10h*10h*10h*10h, 3*10h*10h*10h*10h*10h
           dd  4*10h*10h*10h*10h*10h, 5*10h*10h*10h*10h*10h, 6*10h*10h*10h*10h*10h, 7*10h*10h*10h*10h*10h, 8*10h*10h*10h*10h*10h, 9*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
          dd   0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
align 16
tabl7 dd   0,1*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h 
          dd 4*10h*10h*10h*10h*10h*10h,5*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
           dd   0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
align 16
tabl8  dd    0,1*10h*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h*10h,4*10h*10h*10h*10h*10h*10h*10h 
           dd   5*10h*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
          dd   0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
l_htodw2  endp
l_htodw2_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

REPEAT ncnt
  padd
ENDM

movq_xmm1_edx		equ <dd 0A7E0FF3h>		; equates fix a masm 8+ bug
movq_xmm2_edx8	equ <db 0F3h, 0Fh, 7Eh, 52h, 8>


movq_xmm1_eax		equ <dd 087E0FF3h>		; equates fix a masm 8+ bug
movq_xmm2_eax8	equ <db 0F3h, 0Fh, 7Eh, 50h, 8>
movq_xmm2_eax16	equ <db 0F3h, 0Fh, 7Eh, 50h, 16>

align 16
HexToBin_s:
jq1e	dq 3939393939393939h	; 8* "9"
jq2e	dq 0909090909090909h	; 8* 9
jq3e	dq 0F0F0F0F0F0F0F0Fh	; lowercase

HexToBin proc src
	push ecx
	mov eax, [esp+8]	; get the pointer
	push eax	; save a copy for checking trailing h etc
	movq_xmm1_eax	; movlps much slower on P4
	movdqa xmm0, xmm1
	mov eax, offset jq1e
	pcmpgtb xmm1, [eax]	; jq1 - get info which items are letters
	movq_xmm2_eax16
	pcmpgtb xmm2, xmm0	; compare packed bytes in [m128] and xmm0 for greater than
	pmovmskb edx, xmm2	; set byte mask in eax for second 16 byte chunk
	movq_xmm2_eax8	; load the extra 9 for letters
;	int 3
	andps xmm0, [eax+16]	; jq3 (andps performs a bitwise logical AND, SIMD Floating-Point Exceptions: none
	andps xmm1, xmm2	; jq2 - prepare for adding extra 9
	paddb xmm1, xmm0	; abcdef78
	andps xmm1, [eax+16]	; jq3 again, for the h character
	xorps xmm0, xmm0	; xmm0 may contain garbage, no good for punpcklbw
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
	pshufhw xmm0, xmm0, 01110010b	; cadb
	pshufd xmm0, xmm0, 00100111b	; cadb7e8f
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	packuswb xmm0, xmm0	; pack words to bytes
	movdqa xmm1, xmm0
	psrlq xmm0, 7*4	; interleave: shift right by seven nibbles
	orps xmm0, xmm1	; orps performs a bitwise logical OR, SIMD Floating-Point Exceptions: none
	movd eax, xmm0	; eax: abcdef78
;	int 3
	test edx, edx
	je @F
	bsf edx, edx	; bsf yields valid entries, e.g. 3
	neg edx	; -3
	test edx, edx	; fixes nullstring problem flagged by [url=http://www.masm32.com/board/index.php?topic=14438.msg116901#msg116901]Lingo[/url]
;	cmove eax, edx	; nice instruction but fails e.g. on AMD K6
	.if Zero?
		xor eax, eax	; or mov eax, edx
	.endif
	lea ecx, [4*edx+32]	; +8, *4
	neg edx
	shr eax, cl	; shift them out
	jmp Not8
@@:	add edx, 8	; flag #bytes used
Not8:	pop ecx
	.if byte ptr [ecx+edx]>"F"	; abcdef78h
		inc edx
	.else
		mov cl, byte ptr [ecx+edx-1]	; abcdH, abcdh
		or ecx, 32
		.if cl=="h"
				shr eax, 4						; one nibble to the right
		.endif
	.endif
	pop ecx
	ret 4
HexToBin endp
HexToBin_endp:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

REPEAT ncnt
  padd
ENDM

align 16
Axhex2dw_Unrolled_AMD    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	push esi
	push edi
	push ebx

	UNIT TEXTEQU <DWORD>
	
	mov eax,0
	
	movzx esi,byte ptr [edx]
	movzx edi,byte ptr [edx+1]

	cmp esi,0
	jz @done
	mov eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+2]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+3]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	movzx esi,byte ptr [edx+4]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]
	movzx edi,byte ptr [edx+5]
	cmp esi,0
	jz @done
	shl eax,4
	
	
	
	add eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+6]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+7]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]


	@done:
	pop ebx
	pop edi
	pop esi
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled_AMD    endp
Axhex2dw_Unrolled_AMD_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start
